   .586
.mmx
.xmm

.model flat,stdcall
option casemap:none


literal_string		macro	lit_string
			local	local_string

			.data
			align	4
local_string		db	lit_string, 0

			.code
			exitm	<local_string>
			endm
CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM
CSTR			macro	lit_string
			exitm	<offset literal_string(lit_string)>
			endm

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include shell32.inc
   include comdlg32.inc
   include winmm.inc
   include ole32.inc
   include msvfw32.inc
   include avifil32.inc
   include  advapi32.inc
   include wininet.inc
   include avicap32.inc
   include GDIPlus.inc
   Include masm32.inc
   include ucmacros.asm
   include ArabicConverter.Inc

  
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   includelib winmm.lib
   includelib shell32.lib
	includelib	ole32.lib
	includelib advapi32.lib
	includelib msvfw32.lib
	includelib avifil32.lib
	includelib	oleaut32.lib
	includelib comdlg32.lib
	includelib wininet.lib
	includelib avicap32.lib
	includelib gdiplus.lib
	includelib msvcrt.lib

	
   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD


     m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

.data
   ClassName db "GEF",0
   AppName  db "Farabi Arabic Converter",0
				
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd dword ?
	wDC dword ?
	
	hEdit dword ?
	hEdit2 dword ?
	hBtn dword ?
	dllhnd dword 0
	hFont dword 0

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

SpecialCaseAlif proc uses esi edi lpDestination:dword,lpTextPointed:dword,lpDefaultText:dword
	LOCAL nChar:dword
	
	mov esi,lpTextPointed
	push dword ptr [esi]
	pop nChar
	
	mov eax,nChar
	shr eax,16
	
	.if ah==06h
		recheck:
		.if al==050h
			invoke ucCatStr,lpDestination,uni$("i")
			jmp done
		.elseif al==04Eh
			invoke ucCatStr,lpDestination,uni$("a")
			jmp done
		.elseif al==04Fh
			invoke ucCatStr,lpDestination,uni$("u")
			jmp done
		.elseif al==051h
			add esi,2
			mov ax,[esi]
			jmp recheck
		.elseif al==053h
			add esi,2
			mov ax,[esi]
			jmp recheck
		.elseif al==04Bh
			invoke ucCatStr,lpDestination,uni$("an")
			jmp done
		.elseif al==04Dh
			invoke ucCatStr,lpDestination,uni$("in")
			jmp done
		.elseif al==04Ch
			invoke ucCatStr,lpDestination,uni$("un")
			jmp done
		.endif
	.endif
	
	invoke ucCatStr,lpDestination,lpDefaultText
	
	done:
	invoke ucCatStr,lpDestination,uni$("[")
	invoke ucLen,lpDestination
	mov edx,eax
	shl edx,1
	mov eax,edx
	mov edi,lpDestination
	mov edx,nChar
	mov word ptr[edi+eax],dx
	invoke ucCatStr,lpDestination,uni$("] ")
	ret
SpecialCaseAlif endp

SpecialCaseAin proc uses esi edi lpDestination:dword,lpTextPointed:dword
	LOCAL nChar:dword
	
	mov esi,lpTextPointed
	push dword ptr [esi]
	pop nChar
	
	mov eax,nChar
	shr eax,16
	
	.if ah==06h
		recheck:
		.if al==050h
			invoke ucCatStr,lpDestination,uni$("'i")
			jmp done
		.elseif al==04Eh
			invoke ucCatStr,lpDestination,uni$("'a")
			jmp done
		.elseif al==04Fh
			invoke ucCatStr,lpDestination,uni$("'u")
			jmp done
		.elseif al==051h
			add esi,2
			mov ax,[esi]
			jmp recheck
		.elseif al==053h
			add esi,2
			mov ax,[esi]
			jmp recheck
		.elseif al==04Bh
			invoke ucCatStr,lpDestination,uni$("'an")
			jmp done
		.elseif al==04Dh
			invoke ucCatStr,lpDestination,uni$("'in")
			jmp done
		.elseif al==04Ch
			invoke ucCatStr,lpDestination,uni$("'un")
			jmp done
		.endif
	.endif
	
	invoke ucCatStr,lpDestination,uni$("'a")
	
	done:
	invoke ucCatStr,lpDestination,uni$("[")
	invoke ucLen,lpDestination
	mov edx,eax
	shl edx,1
	mov eax,edx
	mov edi,lpDestination
	mov edx,nChar
	mov word ptr[edi+eax],dx
	invoke ucCatStr,lpDestination,uni$("] ")
	ret
SpecialCaseAin endp

AddArabic proc uses esi edi lpDestination:dword,lpText:dword,lpTextPointed:dword
	LOCAL nChar:dword
	
	mov esi,lpTextPointed
	push dword ptr[esi]
	pop nChar
	
	invoke ucCatStr,lpDestination,lpText
	mov eax,nChar
	shr eax,16
		
	.if ah==06h
		recheck:
		.if al==050h
			invoke ucCatStr,lpDestination,uni$("i")
		.elseif al==04Eh
			invoke ucCatStr,lpDestination,uni$("a")
		.elseif al==04Fh
			invoke ucCatStr,lpDestination,uni$("u")
		.elseif al==051h
			add esi,2
			mov ax,[esi]
			jmp recheck
		.elseif al==053h
			add esi,2
			mov ax,[esi]
			jmp recheck
		.elseif al==04Bh
			invoke ucCatStr,lpDestination,uni$("an")
		.elseif al==04Dh
			invoke ucCatStr,lpDestination,uni$("in")
		.elseif al==04Ch
			invoke ucCatStr,lpDestination,uni$("un")
		.endif
	.endif
	
	done:
	invoke ucCatStr,lpDestination,uni$("[")
	invoke ucLen,lpDestination
	mov edx,eax
	shl edx,1
	mov eax,edx
	mov edi,lpDestination
	mov edx,nChar
	mov word ptr[edi+eax],dx
	invoke ucCatStr,lpDestination,uni$("] ")
	ret
AddArabic endp

DoAnalysis proc uses esi edi ebx lpSource:dword,lpTranslatedBuffer:dword
	LOCAL cntr,ucln:dword
	LOCAL buff[256]:dword
	LOCAL rmndr:dword
	
	mov rmndr,0
	
	mov esi,lpSource
	invoke ucLen,lpSource
	mov ucln,eax
	xor eax,eax
	mov cntr,eax
	_back:
	mov esi,lpSource
	add esi,cntr
	mov ax,[esi]
	.if ax==020h
		pushad
			invoke ucLen,lpTranslatedBuffer
			shl eax,1
			mov ecx,000a000dh
			mov esi,lpTranslatedBuffer
			mov [esi+eax],ecx
		popad
	.endif
	cmp ah,06h
	jnz not_arabic
			
		.if al==022h
			invoke AddArabic,lpTranslatedBuffer,uni$("Aa"),esi
		.elseif al==023h
			;invoke AddArabic,lpTranslatedBuffer,uni$("A"),esi
			invoke SpecialCaseAlif,lpTranslatedBuffer,esi,uni$("A")
		.elseif al==025h
			;invoke AddArabic,lpTranslatedBuffer,uni$("I"),esi
			invoke SpecialCaseAlif,lpTranslatedBuffer,esi,uni$("I")
		.elseif al==026h
			;invoke AddArabic,lpTranslatedBuffer,uni$("A"),esi
			invoke SpecialCaseAlif,lpTranslatedBuffer,esi,uni$("A")
		.elseif al==027h
			;invoke AddArabic,lpTranslatedBuffer,uni$("A"),esi
			invoke SpecialCaseAlif,lpTranslatedBuffer,esi,uni$("A")
		.elseif al==028h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("B"),esi
		.elseif al==029h
			invoke AddArabic,lpTranslatedBuffer,uni$("T"),esi
		.elseif al==02Ah
			invoke AddArabic,lpTranslatedBuffer,uni$("T"),esi
		.elseif al==02Bh
			
			invoke AddArabic,lpTranslatedBuffer,uni$("S"),esi
		.elseif al==02Ch
			
			invoke AddArabic,lpTranslatedBuffer,uni$("J"),esi
		.elseif al==02Dh
			
			invoke AddArabic,lpTranslatedBuffer,uni$("H"),esi	
		.elseif al==02Eh
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Kh"),esi
		.elseif al==02Fh
			
			invoke AddArabic,lpTranslatedBuffer,uni$("D"),esi
		.elseif al==030h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Z"),esi
		.elseif al==031h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("R"),esi
		.elseif al==032h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Z"),esi
		.elseif al==033h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("S"),esi
		.elseif al==034h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Sy"),esi
		.elseif al==035h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("S"),esi
		.elseif al==036h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("D"),esi
		.elseif al==037h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("T"),esi
		.elseif al==038h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Z"),esi
		.elseif al==039h
			
			;invoke AddArabic,lpTranslatedBuffer,uni$("'A"),esi
			invoke SpecialCaseAin,lpTranslatedBuffer,esi
		.elseif al==03Ah
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Gh"),esi
		.elseif al==041h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("F"),esi
		.elseif al==042h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Q"),esi
		.elseif al==043h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("K"),esi
		.elseif al==044h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("L"),esi
		.elseif al==045h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("M"),esi
		.elseif al==046h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("N"),esi
		.elseif al==047h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("H"),esi
		.elseif al==048h
			
			invoke AddArabic,lpTranslatedBuffer,uni$("W"),esi
		.elseif al==021h
			
			;invoke AddArabic,lpTranslatedBuffer,uni$("A"),esi
			invoke SpecialCaseAlif,lpTranslatedBuffer,esi,uni$("A")
		.elseif al==04Ah
			
			invoke AddArabic,lpTranslatedBuffer,uni$("Y"),esi

		.else
		;	invoke AddArabic,lpTranslatedBuffer,uni$("n/a"),esi
		.endif
	not_arabic:
	
	add cntr,2
	mov eax,ucln
	shl eax,1
	cmp cntr,eax
	jle _back
	
	ret
DoAnalysis endp

WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL buff[256]:dword
	LOCAL e:TEXTRANGE
	LOCAL hDC:dword
	LOCAL cntr:dword
	
	.IF uMsg==WM_DESTROY		
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		
		invoke GetSystemMetrics,SM_CXSCREEN
		cmp eax,600
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution width less than 600 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		
		invoke GetSystemMetrics,SM_CYSCREEN
		cmp eax,480
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution height less than 480 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		invoke LoadLibrary,CADD("RICHED20.DLL")
		.if eax!=0
			mov dllhnd,eax
		.else
			invoke PERR
		.endif
;		[Rich edit creation here]
	    mov   edx,WS_VISIBLE or WS_CHILDWINDOW or WS_VSCROLL or ES_NOHIDESEL or ES_AUTOVSCROLL ;or ES_MULTILINE
	    invoke CreateWindowEx,WS_EX_CLIENTEDGE,CADD("RichEdit20W"),NULL,edx,0,0,400,50,hWnd,799,hInstance,NULL
	    mov   hEdit, eax

	    mov   edx,WS_VISIBLE or WS_CHILDWINDOW or WS_VSCROLL or ES_NOHIDESEL or ES_AUTOVSCROLL or ES_MULTILINE
	    invoke CreateWindowEx,WS_EX_CLIENTEDGE,CADD("RichEdit20W"),NULL,edx,0,51,400,200,hWnd,799,hInstance,NULL
	    mov   hEdit2, eax
	    
	    invoke MakeFont,12,10,0,CADD("Courier New")
	    mov hFont,eax
	    invoke SendMessage,hEdit2,WM_SETFONT,eax,TRUE
	    
;		[End of richedit creation]
;		[Button creation here]
		mov edx,WS_CHILD or WS_VISIBLE or BS_BITMAP
		;invoke CreateWindowEx,NULL,CADD("Button"),NULL,edx,10,100,100,30,hWnd,800,hInstance,NULL
		invoke PushButton,CADD("Translate"),hWnd,hInstance,410,0,100,30,800
		mov hBtn,eax
;		[Button creation ends here]
		invoke fCenterWindows,hWnd,600,480
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==800
			invoke memfill,addr buff,1024,32
			lea esi,buff
			mov ax,512
			mov [esi],ax
			invoke SendMessageW,hEdit,EM_GETLINE,0,addr buff
			
			invoke IsWindowUnicode,hEdit
			.if eax==0
				invoke MessageBox,0,CADD("Error: Did not support unicode"),0,0
			.endif
			
   		
   			invoke memfill,addr t2,1024,0
   			invoke DoAnalysis,addr buff,addr t2
   				
   			invoke ucLen,addr t2
   			.if eax>=1
   				invoke SendMessageW,hEdit2,WM_SETTEXT,0,addr t2
   			.endif
   			error:
		.endif
		
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	xor eax,eax
	ret
WndProc endp


end start